"use strict";
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = function(obj, key, value) {
    return key in obj ? __defProp(obj, key, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: value
    }) : obj[key] = value;
};
var __name = function(target, value) {
    return __defProp(target, "name", {
        value: value,
        configurable: true
    });
};
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __copyProps = function(to, from, except, desc) {
    if (from && typeof from === "object" || typeof from === "function") {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            var _loop = function() {
                var key = _step.value;
                if (!__hasOwnProp.call(to, key) && key !== except) __defProp(to, key, {
                    get: function() {
                        return from[key];
                    },
                    enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
                });
            };
            for(var _iterator = __getOwnPropNames(from)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return to;
};
var __toESM = function(mod, isNodeMode, target) {
    return target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(// If the importer is in node compatibility mode or this is not an ESM
    // file that has been converted to a CommonJS file using a Babel-
    // compatible transform (i.e. "__esModule" has not been set), then set
    // "default" to the CommonJS "module.exports" for node compatibility.
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", {
        value: mod,
        enumerable: true
    }) : target, mod);
};
var __toCommonJS = function(mod) {
    return __copyProps(__defProp({}, "__esModule", {
        value: true
    }), mod);
};
var __publicField = function(obj, key, value) {
    __defNormalProp(obj, (typeof key === "undefined" ? "undefined" : _type_of(key)) !== "symbol" ? key + "" : key, value);
    return value;
};
// src/adapter/super-http-client-adapter.ts
var super_http_client_adapter_exports = {};
__export(super_http_client_adapter_exports, {
    SuperHttpClientAdapter: function() {
        return SuperHttpClientAdapter;
    }
});
module.exports = __toCommonJS(super_http_client_adapter_exports);
var import_axios = __toESM(require("axios"));
// src/helpers/http/http.ts
function ok(data, statusCode) {
    return {
        statusCode: statusCode !== null && statusCode !== void 0 ? statusCode : 200,
        data: data
    };
}
__name(ok, "ok");
function created(data) {
    return {
        statusCode: 201,
        data: data
    };
}
__name(created, "created");
function noContent() {
    return {
        statusCode: 204,
        data: void 0
    };
}
__name(noContent, "noContent");
function genericError(error) {
    if (error.response) {
        return {
            statusCode: Number(error.response.status),
            data: error
        };
    }
    if (error.request) {
        return {
            statusCode: 400,
            data: error
        };
    }
    return {
        statusCode: 500,
        data: error
    };
}
__name(genericError, "genericError");
// src/helpers/utils/falsy.ts
function isFalsy(value) {
    return [
        false,
        null,
        void 0
    ].includes(value);
}
__name(isFalsy, "isFalsy");
// src/helpers/utils/truthy.ts
function isTruthy(value) {
    return !isFalsy(value);
}
__name(isTruthy, "isTruthy");
// src/adapter/super-http-client-adapter.ts
var _SuperHttpClientAdapter = /*#__PURE__*/ function() {
    function _SuperHttpClientAdapter(input) {
        _class_call_check(this, _SuperHttpClientAdapter);
        __publicField(this, "THIRTY_SECONDS", 30 * 1e3);
        __publicField(this, "_timeout");
        __publicField(this, "axiosInstance");
        var _input_timeout;
        this._timeout = (_input_timeout = input.timeout) !== null && _input_timeout !== void 0 ? _input_timeout : this.THIRTY_SECONDS;
        this.axiosInstance = import_axios.default.create({
            baseURL: input.baseURL,
            timeout: this._timeout
        });
    }
    _create_class(_SuperHttpClientAdapter, [
        {
            key: "baseURL",
            get: function get() {
                return this.axiosInstance.defaults.baseURL;
            },
            set: function set(baseURL) {
                this.axiosInstance.defaults.baseURL = baseURL;
            }
        },
        {
            key: "timeout",
            get: function get() {
                return this._timeout;
            }
        },
        {
            key: "resolveRouteParams",
            value: function resolveRouteParams(input) {
                var url = input.url;
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = input.routeParams[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var param = _step.value;
                        url = url.replace(param.alias, param.value);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                return url;
            }
        },
        {
            key: "resolveQueryParams",
            value: function resolveQueryParams(input) {
                if (!input.queryParams) {
                    return void 0;
                }
                var queryParams = {};
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = input.queryParams[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var param = _step.value;
                        queryParams[param.name] = param.value;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                return queryParams;
            }
        },
        {
            key: "resolveURL",
            value: function resolveURL(input) {
                var url = input.url;
                if (input.routeParams) {
                    var updatedURL = this.resolveRouteParams({
                        url: url,
                        routeParams: input.routeParams
                    });
                    url = updatedURL;
                }
                return url;
            }
        },
        {
            key: "buildHttpSuccessResponse",
            value: function buildHttpSuccessResponse(response) {
                if (response.status === 201) {
                    return created(response.data);
                }
                if (response.status === 204) {
                    return noContent();
                }
                return ok(response.data, response.status);
            }
        },
        {
            key: "get",
            value: function get(input) {
                var _this = this;
                return _async_to_generator(function() {
                    var resolvedURL, response, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                resolvedURL = _this.resolveURL(input);
                                _state.label = 1;
                            case 1:
                                _state.trys.push([
                                    1,
                                    3,
                                    ,
                                    4
                                ]);
                                return [
                                    4,
                                    _this.axiosInstance.get(resolvedURL, {
                                        baseURL: isTruthy(input.baseURL) ? input.baseURL : _this.baseURL,
                                        timeout: isTruthy(input.timeout) ? input.timeout : _this._timeout,
                                        headers: input.headers,
                                        params: _this.resolveQueryParams({
                                            queryParams: input.queryParams
                                        })
                                    })
                                ];
                            case 2:
                                response = _state.sent();
                                return [
                                    2,
                                    _this.buildHttpSuccessResponse(response)
                                ];
                            case 3:
                                err = _state.sent();
                                return [
                                    2,
                                    genericError(err)
                                ];
                            case 4:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "post",
            value: function post(input) {
                var _this = this;
                return _async_to_generator(function() {
                    var resolvedURL, response, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                resolvedURL = _this.resolveURL(input);
                                _state.label = 1;
                            case 1:
                                _state.trys.push([
                                    1,
                                    3,
                                    ,
                                    4
                                ]);
                                return [
                                    4,
                                    _this.axiosInstance.post(resolvedURL, input.data, {
                                        baseURL: isTruthy(input.baseURL) ? input.baseURL : _this.baseURL,
                                        timeout: isTruthy(input.timeout) ? input.timeout : _this._timeout,
                                        headers: input.headers
                                    })
                                ];
                            case 2:
                                response = _state.sent();
                                return [
                                    2,
                                    _this.buildHttpSuccessResponse(response)
                                ];
                            case 3:
                                err = _state.sent();
                                return [
                                    2,
                                    genericError(err)
                                ];
                            case 4:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "patch",
            value: function patch(input) {
                var _this = this;
                return _async_to_generator(function() {
                    var resolvedURL, response, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                resolvedURL = _this.resolveURL(input);
                                _state.label = 1;
                            case 1:
                                _state.trys.push([
                                    1,
                                    3,
                                    ,
                                    4
                                ]);
                                return [
                                    4,
                                    _this.axiosInstance.patch(resolvedURL, input.data, {
                                        baseURL: isTruthy(input.baseURL) ? input.baseURL : _this.baseURL,
                                        timeout: isTruthy(input.timeout) ? input.timeout : _this._timeout,
                                        headers: input.headers
                                    })
                                ];
                            case 2:
                                response = _state.sent();
                                return [
                                    2,
                                    _this.buildHttpSuccessResponse(response)
                                ];
                            case 3:
                                err = _state.sent();
                                return [
                                    2,
                                    genericError(err)
                                ];
                            case 4:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "put",
            value: function put(input) {
                var _this = this;
                return _async_to_generator(function() {
                    var resolvedURL, response, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                resolvedURL = _this.resolveURL(input);
                                _state.label = 1;
                            case 1:
                                _state.trys.push([
                                    1,
                                    3,
                                    ,
                                    4
                                ]);
                                return [
                                    4,
                                    _this.axiosInstance.put(resolvedURL, input.data, {
                                        baseURL: isTruthy(input.baseURL) ? input.baseURL : _this.baseURL,
                                        timeout: isTruthy(input.timeout) ? input.timeout : _this._timeout,
                                        headers: input.headers
                                    })
                                ];
                            case 2:
                                response = _state.sent();
                                return [
                                    2,
                                    _this.buildHttpSuccessResponse(response)
                                ];
                            case 3:
                                err = _state.sent();
                                return [
                                    2,
                                    genericError(err)
                                ];
                            case 4:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "delete",
            value: function _delete(input) {
                var _this = this;
                return _async_to_generator(function() {
                    var resolvedURL, response, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                resolvedURL = _this.resolveURL(input);
                                _state.label = 1;
                            case 1:
                                _state.trys.push([
                                    1,
                                    3,
                                    ,
                                    4
                                ]);
                                return [
                                    4,
                                    _this.axiosInstance.delete(resolvedURL, {
                                        baseURL: isTruthy(input.baseURL) ? input.baseURL : _this.baseURL,
                                        timeout: isTruthy(input.timeout) ? input.timeout : _this._timeout,
                                        headers: input.headers,
                                        params: _this.resolveQueryParams({
                                            queryParams: input.queryParams
                                        })
                                    })
                                ];
                            case 2:
                                response = _state.sent();
                                return [
                                    2,
                                    _this.buildHttpSuccessResponse(response)
                                ];
                            case 3:
                                err = _state.sent();
                                return [
                                    2,
                                    genericError(err)
                                ];
                            case 4:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "request",
            value: function request(input) {
                var _this = this;
                return _async_to_generator(function() {
                    var resolvedURL, response, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                resolvedURL = _this.resolveURL(input);
                                _state.label = 1;
                            case 1:
                                _state.trys.push([
                                    1,
                                    3,
                                    ,
                                    4
                                ]);
                                return [
                                    4,
                                    _this.axiosInstance.request({
                                        method: input.method,
                                        baseURL: isTruthy(input.baseURL) ? input.baseURL : _this.baseURL,
                                        timeout: isTruthy(input.timeout) ? input.timeout : _this._timeout,
                                        url: resolvedURL,
                                        headers: input.headers,
                                        params: _this.resolveQueryParams({
                                            queryParams: input.queryParams
                                        }),
                                        data: input.data
                                    })
                                ];
                            case 2:
                                response = _state.sent();
                                return [
                                    2,
                                    _this.buildHttpSuccessResponse(response)
                                ];
                            case 3:
                                err = _state.sent();
                                return [
                                    2,
                                    genericError(err)
                                ];
                            case 4:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        }
    ]);
    return _SuperHttpClientAdapter;
}();
__name(_SuperHttpClientAdapter, "SuperHttpClientAdapter");
var SuperHttpClientAdapter = _SuperHttpClientAdapter;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
    SuperHttpClientAdapter: SuperHttpClientAdapter
});
//# sourceMappingURL=super-http-client-adapter.js.map