import { SuperHttpClientAdapter } from './adapter'
import {
  Http,
  HttpHeaders,
  HttpParams,
  HttpProps,
  HttpRequest,
  HttpRequestClient,
  HttpResponse
} from './contracts'
import {
  HttpClient,
  HttpDelete,
  HttpDeleteClient,
  HttpGet,
  HttpGetClient,
  HttpPatch,
  HttpPatchClient,
  HttpPost,
  HttpPostClient,
  HttpPut,
  HttpPutClient
} from './contracts/verbs'

export {
  Http,
  HttpHeaders,
  HttpParams,
  HttpProps,
  HttpRequest,
  HttpRequestClient,
  HttpResponse,
  HttpClient,
  HttpDelete,
  HttpDeleteClient,
  HttpGet,
  HttpGetClient,
  HttpPatch,
  HttpPatchClient,
  HttpPost,
  HttpPostClient,
  HttpPut,
  HttpPutClient,
  SuperHttpClientAdapter
}

export default SuperHttpClientAdapter
