"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = function(target, value) {
    return __defProp(target, "name", {
        value: value,
        configurable: true
    });
};
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __copyProps = function(to, from, except, desc) {
    if (from && typeof from === "object" || typeof from === "function") {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            var _loop = function() {
                var key = _step.value;
                if (!__hasOwnProp.call(to, key) && key !== except) __defProp(to, key, {
                    get: function() {
                        return from[key];
                    },
                    enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
                });
            };
            for(var _iterator = __getOwnPropNames(from)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return to;
};
var __toCommonJS = function(mod) {
    return __copyProps(__defProp({}, "__esModule", {
        value: true
    }), mod);
};
// src/helpers/http/http.ts
var http_exports = {};
__export(http_exports, {
    created: function() {
        return created;
    },
    genericError: function() {
        return genericError;
    },
    noContent: function() {
        return noContent;
    },
    ok: function() {
        return ok;
    }
});
module.exports = __toCommonJS(http_exports);
function ok(data, statusCode) {
    return {
        statusCode: statusCode !== null && statusCode !== void 0 ? statusCode : 200,
        data: data
    };
}
__name(ok, "ok");
function created(data) {
    return {
        statusCode: 201,
        data: data
    };
}
__name(created, "created");
function noContent() {
    return {
        statusCode: 204,
        data: void 0
    };
}
__name(noContent, "noContent");
function genericError(error) {
    if (error.response) {
        return {
            statusCode: Number(error.response.status),
            data: error
        };
    }
    if (error.request) {
        return {
            statusCode: 400,
            data: error
        };
    }
    return {
        statusCode: 500,
        data: error
    };
}
__name(genericError, "genericError");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
    created: created,
    genericError: genericError,
    noContent: noContent,
    ok: ok
});
//# sourceMappingURL=http.js.map